Subject: bug#30423: 2018-01-25; [patch] flymake support

From: Alex Branham <[email-masked]>
Date: Fri, 16 Feb 2018 09:10:28 -0600

On Fri 16 Feb 2018 at 02:37, Mosè Giordano <[email-masked]> wrote:

> Hi Alex,
>
> thanks again for your contribution.  I think it's fine in principle to
> support Flymake, as long as this doesn't introduce dependence on
> external packages.  We strive to keep dependencies as low as possible.

Understood, no dependencies added here.

> 2018-02-11 19:06 GMT+01:00 Alex Branham <[email-masked]>:
>> Flymake got a major rewrite in Emacs 26, the attached patch adds support for this in latex.el. Users can enable it by calling adding flymake-mode to LaTeX-mode-hook.
>>
>> From 0b8eeebd01d0ed25823d4f40a7ab3cff0d150b8f Mon Sep 17 00:00:00 2001
>> From: Alex Branham <[email-masked]>
>> Date: Sun, 11 Feb 2018 11:54:09 -0600
>> Subject: [PATCH] Support flymake in Emacs 26+ using chktex
>>
>> ---
>>  latex.el | 73 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
>>  1 file changed, 72 insertions(+), 1 deletion(-)
>>
>> diff --git a/latex.el b/latex.el
>> index c2d8a4ca..e3792faf 100644
>> --- a/latex.el
>> +++ b/latex.el
>> @@ -1,4 +1,4 @@
>> -;;; latex.el --- Support for LaTeX documents.
>> +;;; latex.el --- Support for LaTeX documents.  -*- lexical-binding: t; -*-
>
> I'm concerned by this change.  We haven't used lexical binding so far
> because we used to support very old Emacsens.  While this change may
> be desirable, I've the feeling that AUCTeX relies on dynamic binding.
> I've opened a ticket as a memo for anyone willing to work on it:
> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=30484.

I believe lexical binding was added in Emacs 24. Since auctex requires
Emacs 24.3 or newer, I don't think this should be an issue. Or am I
missing something?

> Does your patch fundamentally rely on lexical binding or can work also
> with dynamic binding?

As written, it won't work with dynamic binding.

> In addition, I'm not sure latex.el is the right place for this.  The
> file contains only stuff for editing LaTeX documents.  For example,
> support for ispell is in its own module, required by latex.el.  What
> other people thinks about this?

We could kill two birds with one stone by adding a new file
latex-flymake.el or something that uses lexical-binding.

Thanks for the comments!
Alex